import type { CheqdSDK, DidStdFee, DIDDocument } from '@cheqd/sdk';
import type { SignInfo } from '@cheqd/ts-proto/cheqd/did/v2';
import type { MsgCreateResourcePayload } from '@cheqd/ts-proto/cheqd/resource/v2';
import type { DirectSecp256k1HdWallet, DirectSecp256k1Wallet } from '@cosmjs/proto-signing';
import { CheqdModuleConfig } from '../CheqdModuleConfig';
export interface ICheqdLedgerConfig {
    network: string;
    rpcUrl: string;
    readonly cosmosPayerWallet: Promise<DirectSecp256k1HdWallet | DirectSecp256k1Wallet>;
    sdk?: CheqdSDK;
}
export declare enum DefaultRPCUrl {
    Mainnet = "https://rpc.cheqd.net",
    Testnet = "https://rpc.cheqd.network"
}
export declare class CheqdLedgerService {
    private networks;
    constructor(cheqdSdkModuleConfig: CheqdModuleConfig);
    connect(): Promise<void>;
    private getSdk;
    create(didPayload: DIDDocument, signInputs: SignInfo[], versionId?: string | undefined, fee?: DidStdFee): Promise<import("@cosmjs/stargate").DeliverTxResponse>;
    update(didPayload: DIDDocument, signInputs: SignInfo[], versionId?: string | undefined, fee?: DidStdFee): Promise<import("@cosmjs/stargate").DeliverTxResponse>;
    deactivate(didPayload: DIDDocument, signInputs: SignInfo[], versionId?: string | undefined, fee?: DidStdFee): Promise<import("@cosmjs/stargate").DeliverTxResponse>;
    resolve(did: string, version?: string): Promise<import("@cheqd/sdk").DIDDocumentWithMetadata>;
    resolveMetadata(did: string): Promise<{
        didDocumentVersionsMetadata: import("did-resolver").DIDDocumentMetadata[];
        pagination: import("@cheqd/ts-proto/cosmos/base/query/v1beta1/pagination").PageResponse | undefined;
    }>;
    createResource(did: string, resourcePayload: Partial<MsgCreateResourcePayload>, signInputs: SignInfo[], fee?: DidStdFee): Promise<import("@cosmjs/stargate").DeliverTxResponse>;
    resolveResource(did: string, collectionId: string, resourceId: string): Promise<import("@cheqd/ts-proto/cheqd/resource/v2").ResourceWithMetadata>;
    resolveCollectionResources(did: string, collectionId: string): Promise<import("@cheqd/ts-proto/cheqd/resource/v2").QueryCollectionResourcesResponse>;
    resolveResourceMetadata(did: string, collectionId: string, resourceId: string): Promise<import("@cheqd/ts-proto/cheqd/resource/v2").Metadata>;
}
